'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var PropTypes = require('prop-types');
var reactSyntaxHighlighter = require('react-syntax-highlighter');
var javascript = require('react-syntax-highlighter/dist/esm/languages/prism/javascript');
var jsx = require('react-syntax-highlighter/dist/esm/languages/prism/jsx');
var typescript = require('react-syntax-highlighter/dist/esm/languages/prism/typescript');
var tsx = require('react-syntax-highlighter/dist/esm/languages/prism/tsx');
var yaml = require('react-syntax-highlighter/dist/esm/languages/prism/yaml');
var json = require('react-syntax-highlighter/dist/esm/languages/prism/json');
var prism = require('react-syntax-highlighter/dist/esm/styles/prism/prism');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var PropTypes__default = /*#__PURE__*/_interopDefaultLegacy(PropTypes);
var javascript__default = /*#__PURE__*/_interopDefaultLegacy(javascript);
var jsx__default = /*#__PURE__*/_interopDefaultLegacy(jsx);
var typescript__default = /*#__PURE__*/_interopDefaultLegacy(typescript);
var tsx__default = /*#__PURE__*/_interopDefaultLegacy(tsx);
var yaml__default = /*#__PURE__*/_interopDefaultLegacy(yaml);
var json__default = /*#__PURE__*/_interopDefaultLegacy(json);
var prism__default = /*#__PURE__*/_interopDefaultLegacy(prism);

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var languages = {
  javascript: javascript__default['default'],
  jsx: jsx__default['default'],
  typescript: typescript__default['default'],
  tsx: tsx__default['default'],
  yaml: yaml__default['default'],
  json: json__default['default'],
  prism: prism__default['default']
};
var Code = function Code(_ref) {
  var children = _ref.children,
      inline = _ref.inline,
      _ref$language = _ref.language,
      language = _ref$language === void 0 ? 'jsx' : _ref$language;
  React.useEffect(function () {
    reactSyntaxHighlighter.PrismLight.registerLanguage(language, languages[language]);
  }, [language]);
  var lines = children.split('\n'); // find first and last non-empty lines, and slice

  if (lines.length > 1) {
    var firstLine = lines.findIndex(function (l) {
      return l.trim().length > 0;
    });

    var lastLine = _toConsumableArray(lines).reverse().findIndex(function (l) {
      return l.trim().length > 0;
    });

    lines = lines.slice(firstLine, -lastLine);
  } // find number of leading spaces to trim


  var leadingSpaces = Math.min.apply(Math, _toConsumableArray(lines.filter(function (l) {
    return l.trim().length > 0;
  }).map(function (l) {
    return l.slice(0, l.search(/[^\s]/)).length;
  })));
  lines = lines.map(function (l) {
    return l.slice(leadingSpaces);
  });
  var code = lines.join('\n');
  return /*#__PURE__*/React__default['default'].createElement(reactSyntaxHighlighter.PrismLight, {
    language: language,
    style: prism__default['default'],
    wrapLongLines: true,
    customStyle: {
      display: inline ? 'inline-block' : 'block'
    }
  }, code);
};
Code.propTypes = {
  children: PropTypes__default['default'].string,
  inline: PropTypes__default['default'].bool,
  language: PropTypes__default['default'].oneOf(['javascript', 'jsx', 'typescript', 'tsx', 'yaml', 'json'])
};

exports.Code = Code;
