import React, { useEffect } from 'react';
import PropTypes from 'prop-types';
import { PrismLight } from 'react-syntax-highlighter';
import javascript from 'react-syntax-highlighter/dist/esm/languages/prism/javascript';
import jsx from 'react-syntax-highlighter/dist/esm/languages/prism/jsx';
import typescript from 'react-syntax-highlighter/dist/esm/languages/prism/typescript';
import tsx from 'react-syntax-highlighter/dist/esm/languages/prism/tsx';
import yaml from 'react-syntax-highlighter/dist/esm/languages/prism/yaml';
import json from 'react-syntax-highlighter/dist/esm/languages/prism/json';
import prism from 'react-syntax-highlighter/dist/esm/styles/prism/prism';

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var languages = {
  javascript: javascript,
  jsx: jsx,
  typescript: typescript,
  tsx: tsx,
  yaml: yaml,
  json: json,
  prism: prism
};
var Code = function Code(_ref) {
  var children = _ref.children,
      inline = _ref.inline,
      _ref$language = _ref.language,
      language = _ref$language === void 0 ? 'jsx' : _ref$language;
  useEffect(function () {
    PrismLight.registerLanguage(language, languages[language]);
  }, [language]);
  var lines = children.split('\n'); // find first and last non-empty lines, and slice

  if (lines.length > 1) {
    var firstLine = lines.findIndex(function (l) {
      return l.trim().length > 0;
    });

    var lastLine = _toConsumableArray(lines).reverse().findIndex(function (l) {
      return l.trim().length > 0;
    });

    lines = lines.slice(firstLine, -lastLine);
  } // find number of leading spaces to trim


  var leadingSpaces = Math.min.apply(Math, _toConsumableArray(lines.filter(function (l) {
    return l.trim().length > 0;
  }).map(function (l) {
    return l.slice(0, l.search(/[^\s]/)).length;
  })));
  lines = lines.map(function (l) {
    return l.slice(leadingSpaces);
  });
  var code = lines.join('\n');
  return /*#__PURE__*/React.createElement(PrismLight, {
    language: language,
    style: prism,
    wrapLongLines: true,
    customStyle: {
      display: inline ? 'inline-block' : 'block'
    }
  }, code);
};
Code.propTypes = {
  children: PropTypes.string,
  inline: PropTypes.bool,
  language: PropTypes.oneOf(['javascript', 'jsx', 'typescript', 'tsx', 'yaml', 'json'])
};

export { Code };
